#property copyright "Average Spectrum (c) HotFx 2011.07.21"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru
#property indicator_separate_window
#property indicator_buffers 8

extern int Per            = 5;
extern int Num            = 8;
extern string SoundTrend  = "email.wav";

int mod = MODE_SMA, typ = PRICE_CLOSE, buy = Blue, sel = Red, not = MintCream, own = Gold, maxNum = 8;
int p1, p2, p4, p8, p16, p32, p64, p128, diff, bm, sm, obm = 0, osm = 0;
double x1[], x2[], x4[], x8[], x16[], x32[], x64[], x128[], divPer;
string info;

void init()
 {
  if (Per < 1) Per = 1;
  if (Num < 1) Num = 1;
  if (Num > maxNum) Num = maxNum;
  divPer = Per / MathPow(2, (maxNum - Num)); info ="("; diff = Num - 1;
  SetIndexBuffer(0, x128); SetIndexStyle(0, DRAW_LINE, EMPTY, EMPTY, own);
  p128 = MathRound(divPer * 128); info = info + p128;
  if (Num > 1) { SetIndexBuffer(1, x64); p64 = MathRound(divPer * 64); info = info + "-" + p64; }
  if (Num > 2) { SetIndexBuffer(2, x32); p32 = MathRound(divPer * 32); info = info + "-" + p32; }
  if (Num > 3) { SetIndexBuffer(3, x16); p16 = MathRound(divPer * 16); info = info + "-" + p16; }
  if (Num > 4) { SetIndexBuffer(4,  x8);  p8 = MathRound(divPer *  8); info = info + "-" + p8;  }
  if (Num > 5) { SetIndexBuffer(5,  x4);  p4 = MathRound(divPer *  4); info = info + "-" + p4;  }
  if (Num > 6) { SetIndexBuffer(6,  x2);  p2 = MathRound(divPer *  2); info = info + "-" + p2;  }
  if (Num > 7) { SetIndexBuffer(7,  x1);  p1 = MathRound(divPer *  1); info = info + "-" + p1;  }
  info = info + ")";
 }

void start()
 {
  int limit;
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars --;
  limit = Bars - counted_bars;
  for (int i = 0; i < limit; i ++)  
   {
    x128[i] = iMA(NULL, 0, p128, 0, mod, typ, i);
    if (Num > 1) x64[i] = iMA(NULL, 0, p64, 0, mod, typ, i);
    if (Num > 2) x32[i] = iMA(NULL, 0, p32, 0, mod, typ, i);
    if (Num > 3) x16[i] = iMA(NULL, 0, p16, 0, mod, typ, i);
    if (Num > 4)  x8[i] = iMA(NULL, 0,  p8, 0, mod, typ, i);
    if (Num > 5)  x4[i] = iMA(NULL, 0,  p4, 0, mod, typ, i);
    if (Num > 6)  x2[i] = iMA(NULL, 0,  p2, 0, mod, typ, i);
    if (Num > 7)  x1[i] = iMA(NULL, 0,  p1, 0, mod, typ, i);
   }
  bm = 0; sm = 0; 
  if (Num > 1) if (x64[0] > x128[0]) {bm ++; SetIndexStyle(1, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if (x64[0] < x128[0])  {sm ++; SetIndexStyle(1, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(1, DRAW_LINE, EMPTY, EMPTY, not);

  if (Num > 2) if ((x32[0] > x64[0]) && (x32[0] > x128[0])) {bm ++; SetIndexStyle(2, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x32[0] < x64[0]) && (x32[0] < x128[0]))  {sm ++; SetIndexStyle(2, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(2, DRAW_LINE, EMPTY, EMPTY, not);

  if (Num > 3) if ((x16[0] > x32[0]) && (x16[0] > x128[0])) {bm ++; SetIndexStyle(3, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x16[0] < x32[0]) && (x16[0] < x128[0]))  {sm ++; SetIndexStyle(3, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(3, DRAW_LINE, EMPTY, EMPTY, not);
    
  if (Num > 4) if ((x8[0] > x16[0]) && (x8[0] > x128[0])) {bm ++; SetIndexStyle(4, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x8[0] < x16[0]) && (x8[0] < x128[0]))  {sm ++; SetIndexStyle(4, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(4, DRAW_LINE, EMPTY, EMPTY, not);

  if (Num > 5) if ((x4[0] > x8[0]) && (x4[0] > x128[0])) {bm ++; SetIndexStyle(5, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x4[0] < x8[0]) && (x4[0] < x128[0]))  {sm ++; SetIndexStyle(5, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(5, DRAW_LINE, EMPTY, EMPTY, not);
    
  if (Num > 6) if ((x2[0] > x4[0]) && (x2[0] > x128[0])) {bm ++; SetIndexStyle(6, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x2[0] < x4[0]) && (x2[0] < x128[0]))  {sm ++; SetIndexStyle(6, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(6, DRAW_LINE, EMPTY, EMPTY, not);
         
  if (Num > 7) if ((x1[0] > x2[0]) && (x1[0] > x128[0])) {bm ++; SetIndexStyle(7, DRAW_LINE, EMPTY, EMPTY, buy); }
               else if ((x1[0] < x2[0]) && (x1[0] < x128[0]))  {sm ++; SetIndexStyle(7, DRAW_LINE, EMPTY, EMPTY, sel); }
                    else SetIndexStyle(7, DRAW_LINE, EMPTY, EMPTY, not);
  IndicatorShortName(" BUY  " + bm + "  < " + diff + " >  " + sm + "  SELL  " + info);
  if ( ((obm != diff) && (bm == diff)) || ((osm != diff) && (sm == diff)) ) if (SoundTrend!="") PlaySound(SoundTrend);
  obm = bm; osm = sm;
 } //start

